/*
 * (C) Copyright 2005
 * Micrel, Inc. <www.micrel.com>
 *
 * (C) Copyright 2005
 * Greg Ungerer <greg.ungerer@opengear.com>.
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#ifndef __CONFIG_H
#define __CONFIG_H

/*
 * Choose only one of the board configuration
 */
#define CFG_BOARD_KS8695PX

#ifdef CFG_BOARD_KS8695X
#define CONFIG_NR_DRAM_BANKS	1		/* 1 bank of DRAM */
#define	CFG_FLASH_SIZE		0x400000
#define CFG_MAX_FLASH_BANKS	1		/* number of flash banks */
#define MEMORY_CONFIGURATION	0x10000001	/* one 8bit flash */
#define SDRAM_BANK_REG1		0
#define PHYS_FLASH_1		0x02000000	/* Flash Bank #1 */
#define REMAPPED_FLASH_REG0	0x8fe00040	/* 0x2000000 - 0x23fffff */
#define REMAPPED_FLASH_REG1	0		/* not used */
/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define PHYS_FLASH_SECT_SIZE    0x00010000	/* 64 KB sectors (x1) */
#define	U_BOOT_CODE_SIZE	0x00020000	/* 128KB */
#define CFG_ENV_ADDR		(PHYS_FLASH_1 + U_BOOT_CODE_SIZE)
#define CFG_ENV_SECT_SIZE	PHYS_FLASH_SECT_SIZE	/* 64 KB sectors (x1) */
#define CFG_ENV_SIZE		PHYS_FLASH_SECT_SIZE	/* Total Size of Environment */
#define CONFIG_BOOTCOMMAND	"bootm 0x02030000"
#endif

#ifdef CFG_BOARD_KS8695PX
#define CONFIG_NR_DRAM_BANKS	2		/* 2 banks of DRAM */
#define	CFG_FLASH_SIZE		0x400000
#define CFG_MAX_FLASH_BANKS	1		/* number of flash banks */
#define MEMORY_CONFIGURATION	0x10000001	/* one 8bit flash */
#define SDRAM_BANK_REG1		0x7fd0000e	/* 0x1000000 - 0x1ffffff */
#define PHYS_FLASH_1		0x02000000	/* Flash Bank #1 */
#define REMAPPED_FLASH_REG0	0x8fe00040	/* 0x2000000 - 0x23fffff */
#define REMAPPED_FLASH_REG1	0		/* not used */
/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define PHYS_FLASH_SECT_SIZE    0x00010000	/* 64 KB sectors (x1) */
#define	U_BOOT_CODE_SIZE	0x00020000	/* 128KB */
#define CFG_ENV_ADDR		(PHYS_FLASH_1 + U_BOOT_CODE_SIZE)
#define CFG_ENV_SECT_SIZE	PHYS_FLASH_SECT_SIZE	/* 64 KB sectors (x1) */
#define CFG_ENV_SIZE		PHYS_FLASH_SECT_SIZE	/* Total Size of Environment */
#define CONFIG_BOOTCOMMAND	"bootm 0x02030000"
#endif

#ifdef CFG_BOARD_KS8695P_VOIP
#define CONFIG_NR_DRAM_BANKS	2		/* 2 banks of DRAM */
#define	CFG_FLASH_SIZE		0x400000
#define CFG_MAX_FLASH_BANKS	1		/* number of flash banks */
#define MEMORY_CONFIGURATION	0x10000002	/* one 16bit flash */
#define SDRAM_BANK_REG1		0x7fd0000e	/* 0x1000000 - 0x1ffffff */
#define CFG_FLASH_CFI_WIDTH	FLASH_CFI_16BIT
#define PHYS_FLASH_1		0x03000000	/* Flash Bank #1 */
#define REMAPPED_FLASH_REG0	0xcff00040	/* 0x3000000 - 0x33fffff */
#define REMAPPED_FLASH_REG1	0		/* not used */
/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define PHYS_FLASH_SECT_SIZE    0x00010000	/* 64 KB sectors (x1) */
#define	U_BOOT_CODE_SIZE	0x00020000	/* 128KB */
#define CFG_ENV_ADDR		(PHYS_FLASH_1 + U_BOOT_CODE_SIZE)
#define CFG_ENV_SECT_SIZE	PHYS_FLASH_SECT_SIZE	/* 64 KB sectors (x1) */
#define CFG_ENV_SIZE		PHYS_FLASH_SECT_SIZE	/* Total Size of Environment */
#define CONFIG_BOOTCOMMAND	"bootm 0x03030000"
#define FLASH_LOCATED_HIGH	/* used when FLASH_BASE to 0x3000000 */
#endif

#ifdef CFG_BOARD_KS8695P_MMB
#define CONFIG_NR_DRAM_BANKS	2		/* 2 banks of DRAM */
#define	CFG_FLASH_SIZE		0x800000
#define CFG_MAX_FLASH_BANKS	1		/* number of flash banks */
#define MEMORY_CONFIGURATION	0x10000003	/* in 32bit config */
#define SDRAM_BANK_REG1		0x7fd0000e	/* 0x1000000 - 0x1ffffff */
#define CFG_FLASH_CFI_WIDTH	FLASH_CFI_32BIT
#define PHYS_FLASH_1		0x03000000	/* Flash Bank #1 */
#define REMAPPED_FLASH_REG0	0xdff00040	/* 0x3000000 - 0x37fffff */
#define REMAPPED_FLASH_REG1	0
/*-----------------------------------------------------------------------
 * FLASH and environment organization
 * Only applied for AMD29LV320DB Flash - Limit U-Boot to 112KB and ENV to 16KB
 */
#define PHYS_FLASH_SECT_SIZE    0x00020000	/* 128 KB sectors */
#define	U_BOOT_CODE_SIZE	0x0001c000	/* 112KB */
#define CFG_ENV_ADDR		(PHYS_FLASH_1 + U_BOOT_CODE_SIZE)
#define CFG_ENV_SECT_SIZE	0x00004000	/* 16 KB sectors */
#define CFG_ENV_SIZE		0x00004000	/* Total Size of Environment */
#define CONFIG_BOOTCOMMAND	"bootm 0x03030000"
#define FLASH_LOCATED_HIGH	/* used when FLASH_BASE to 0x3000000 */
#endif

/*
 * High Level Configuration Options
 * (easy to change)
 */
#define CONFIG_IDENT_STRING		" Micrel 1.0"
#define CONFIG_KS8695	1		/* it is a KS8695 CPU */

/* It is a KS8695P chip. */
#define CONFIG_KS8695P  1		/* it is KS8695P based */
#define CONFIG_ARCH_KS8695P	1

#define CONFIG_CMDLINE_TAG	 1	/* enable passing of ATAGs	*/
#define CONFIG_SETUP_MEMORY_TAGS 1
#define CONFIG_INITRD_TAG	 1

#define CFG_FLASH_CFI				/* use the Common Flash Interface */
#define CFG_FLASH_CFI_DRIVER			/* use the CFI driver */
#undef CFG_FLASH_CHECKSUM
#define CFG_FLASH_QUIET_TEST

#define CONFIG_DRIVER_KS8695ETH		/* use KS8695 ethernet driver	*/

#define CFG_MALLOC_LEN		(CFG_ENV_SIZE + 128*1024)

/*
 * Size of malloc() pool
 */
#define CFG_GBL_DATA_SIZE	128	/* size in bytes reserved for initial data */

/*
 * select serial console configuration
 */
#define CFG_ENV_IS_IN_FLASH     1	/*save the uboot environment variables in flash */

#define	CONFIG_SERIAL1
#define CONFIG_CONS_INDEX	1
#define CONFIG_BAUDRATE		115200
#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }


/*
 * Include additional commands here
 */

/* this must be included AFTER the definition of CONFIG_COMMANDS (if any) */
#include <cmd_confdefs.h>
#undef CONFIG_COMMANDS

#define	CONFIG_COMMANDS		(CONFIG_CMD_DFL)

#define CONFIG_BOOTDELAY	3
#define CONFIG_BOOTARGS		"console=ttyAM0,115200"

/* uboot(0x20000) + env */

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP				/* undef to save memory		*/
#define CFG_PROMPT		"boot > "	/* Monitor Command Prompt	*/
#define CFG_CBSIZE		256		/* Console I/O Buffer Size	*/
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16) /* Print Buffer Size */
#define CFG_MAXARGS		16		/* max number of command args	*/
#define CFG_BARGSIZE		CFG_CBSIZE	/* Boot Argument Buffer Size	*/

#define CFG_MEMTEST_START	0x00800000	/* memtest works on	*/
#define CFG_MEMTEST_END		0x02000000	/* 32 MB in DRAM	*/

#undef	CFG_CLKS_IN_HZ		/* everything, incl board info, in Hz */

#define CFG_LOAD_ADDR		0x00008000	/* default load address */

#define CFG_HZ			(1000)		/* 1ms resolution ticks */

/*-----------------------------------------------------------------------
 * Stack sizes
 *
 * The stack sizes are set up in start.S using the settings below
 */
#define CONFIG_STACKSIZE	(128*1024)	/* regular stack */

/*-----------------------------------------------------------------------
 * Physical Memory Map
 */
#define PHYS_SDRAM_SIZE		0x01000000 /* 16 MB */

#define PHYS_SDRAM_1		0x00000000 /* SDRAM Bank #1 */
#define PHYS_SDRAM_1_SIZE	PHYS_SDRAM_SIZE

#if ( CONFIG_NR_DRAM_BANKS > 1 )
#define PHYS_SDRAM_2		PHYS_SDRAM_1 + PHYS_SDRAM_1_SIZE
#define PHYS_SDRAM_2_SIZE	PHYS_SDRAM_SIZE
#else
#define PHYS_SDRAM_2		0
#define PHYS_SDRAM_2_SIZE	0
#endif

#define CFG_FLASH_BASE		PHYS_FLASH_1
#define CFG_MONITOR_BASE	CFG_FLASH_BASE


#define CFG_MAX_FLASH_SECT	(128)	/* max number of sectors on one chip */

/* timeout values are in ticks */
#define CFG_FLASH_WRITE_TOUT	(CFG_HZ)	/* Timeout for Flash Write */
#define CFG_FLASH_ERASE_TOUT	(2*CFG_HZ)	/* Timeout for Flash Erase */


#define	CONFIG_ETHADDR		00:10:A1:86:95:01
#define	CONFIG_IPADDR		192.168.1.200
#define	CONFIG_NETMASK		255.255.255.0
#define	CONFIG_SERVERIP 	192.168.1.11
#define	CONFIG_ENV_OVERWRITE

#define	CONFIG_AUTOSCRIPT	1

#define CFG_AUTOLOAD		"n"
#define	CFG_ENV_OVERWRITE	1
#define	UBOOT_LOAD_RAMDISK	(TEXT_BASE - CFG_FLASH_SIZE)

#define LARGE_FLASH_MAP		0xffc00040
#endif	/* __CONFIG_H */
